## ros-indigo-multisense-lib 4.0.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.3)
project(multisense_lib)

## Find catkin macros and libraries
## if COMPONENTS list like find_package(catkin REQUIRED COMPONENTS xyz)
## is used, also find other catkin packages
find_package(catkin REQUIRED COMPONENTS cv_bridge)


catkin_destinations()  # get catkin variable defines for destinations
set(BASE_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR})
set(SOURCE_DIRECTORY /sensor_api)
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CATKIN_DEVEL_PREFIX}/${CATKIN_PACKAGE_LIB_DESTINATION})
set (CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CATKIN_DEVEL_PREFIX}/${CATKIN_PACKAGE_BIN_DESTINATION})
set (OpenCV_LIBS ${catkin_LIBRARIES})

## Mark cpp header files for installation
file(GLOB LIBMULTISENSE_HEADERS
  "sensor_api/source/LibMultiSense/*.hh"
)

file(MAKE_DIRECTORY ${BASE_DIRECTORY}/include/${PROJECT_NAME})
file(INSTALL ${LIBMULTISENSE_HEADERS} DESTINATION ${BASE_DIRECTORY}/include/${PROJECT_NAME})
include_directories(include)


## Declare a catkin package
catkin_package(INCLUDE_DIRS include
               CATKIN_DEPENDS cv_bridge
               LIBRARIES MultiSense)

# Build the libraries
add_subdirectory(sensor_api)


# install utilities
# TODO: how to move install target of bin into devel?
install(PROGRAMS
  ${CATKIN_DEVEL_PREFIX}/${CATKIN_PACKAGE_BIN_DESTINATION}/ChangeIpUtility
  ${CATKIN_DEVEL_PREFIX}/${CATKIN_PACKAGE_BIN_DESTINATION}/DeviceInfoUtility
  ${CATKIN_DEVEL_PREFIX}/${CATKIN_PACKAGE_BIN_DESTINATION}/FlashUtility
  ${CATKIN_DEVEL_PREFIX}/${CATKIN_PACKAGE_BIN_DESTINATION}/ImageCalUtility
  ${CATKIN_DEVEL_PREFIX}/${CATKIN_PACKAGE_BIN_DESTINATION}/ImuConfigUtility
  ${CATKIN_DEVEL_PREFIX}/${CATKIN_PACKAGE_BIN_DESTINATION}/ImuTestUtility
  ${CATKIN_DEVEL_PREFIX}/${CATKIN_PACKAGE_BIN_DESTINATION}/LidarCalUtility
  ${CATKIN_DEVEL_PREFIX}/${CATKIN_PACKAGE_BIN_DESTINATION}/MultiSenseUpdater
  ${CATKIN_DEVEL_PREFIX}/${CATKIN_PACKAGE_BIN_DESTINATION}/SaveImageUtility
  DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
)

install(DIRECTORY include/${PROJECT_NAME}/
        DESTINATION ${CATKIN_PACKAGE_INCLUDE_DESTINATION}
        FILES_MATCHING PATTERN "*.hh"
)

=== sensor_api/source/LibMultiSense/CMakeLists.txt ===
#
# MultiSense - Makefile
#

#
# Platform checks
#

include(CheckFunctionExists)

check_function_exists(vasprintf HAVE_VASPRINTF)

#
# Include all of our child directories.
#

include_directories ( .
                      ${BASE_DIRECTORY}/external/include
                    )

set(MULTISENSE_HEADERS MultiSenseChannel.hh
                       MultiSenseTypes.hh)

set(DETAILS_HEADERS details/channel.hh
                    details/query.hh
                    details/listeners.hh
                    details/signal.hh
                    details/storage.hh)

set(DETAILS_SRC details/channel.cc
                details/public.cc
                details/flash.cc
                details/dispatch.cc
                details/utility/Constants.cc
                details/utility/TimeStamp.cc
                details/utility/Exception.cc)

if(NOT HAVE_VASPRINTF)
    add_definitions(-DNEED_VASPRINTF=1)
endif()

#
# Add in all of the source files in this directory.
#

add_library(MultiSense SHARED ${MULTISENSE_HEADERS}
                              ${DETAILS_HEADERS}
                              ${DETAILS_SRC})
#
# Versioning...someday lets automate this somehow
#

set_target_properties(MultiSense PROPERTIES VERSION "3.8")

#
# We want to link against our child libraries.
#

if(${CMAKE_SYSTEM_NAME} MATCHES "Windows")
    target_link_libraries(MultiSense ws2_32)
else()
    target_link_libraries(MultiSense pthread rt)
endif()

# create install targets
install(TARGETS MultiSense
  LIBRARY DESTINATION lib
  ARCHIVE DESTINATION lib
  RUNTIME DESTINATION bin
)

install(FILES ${MULTISENSE_HEADERS} DESTINATION include/MultiSense)

=== sensor_api/source/Utilities/DeviceInfoUtility/CMakeLists.txt ===
#
# DeviceInfoUtility - Makefile
#

#
# Setup the executable that we will use.
#

add_executable(DeviceInfoUtility DeviceInfoUtility.cc)

#
# Specify libraries against which to link.
#

target_link_libraries (DeviceInfoUtility ${MULTISENSE_UTILITY_LIBS})

=== sensor_api/source/Utilities/ExternalCalUtility/CMakeLists.txt ===
#
# ExternalCalUtility - Makefile
#

#
# Setup the executable that we will use.
#

add_executable(ExternalCalUtility ExternalCalUtility.cc)

#
# Specify libraries against which to link.
#

target_link_libraries (ExternalCalUtility ${MULTISENSE_UTILITY_LIBS})

=== sensor_api/source/Utilities/FlashUtility/CMakeLists.txt ===
#
# FlashUtility - Makefile
#

#
# Setup the executable that we will use.
#

add_executable(FlashUtility FlashUtility.cc)

#
# Specify libraries against which to link.
#

target_link_libraries (FlashUtility ${MULTISENSE_UTILITY_LIBS})

if(${CMAKE_SYSTEM_NAME} MATCHES "Windows")
else()
    add_custom_target(MultiSenseUpdater ALL
                      DEPENDS FlashUtility
                      COMMAND ${CMAKE_COMMAND} -E copy ${CMAKE_CURRENT_SOURCE_DIR}/_MultiSenseUpdater
                      ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/MultiSenseUpdater)

endif()

=== sensor_api/source/Utilities/SaveImageUtility/CMakeLists.txt ===
#
# SaveImageUtility - Makefile
#

#
# Setup the executable that we will use.
#

add_executable(SaveImageUtility SaveImageUtility.cc)

#
# Specify libraries against which to link.
#

target_link_libraries (SaveImageUtility ${MULTISENSE_UTILITY_LIBS})

=== sensor_api/source/Utilities/SensorCalUtility/CMakeLists.txt ===
#
# SensorCalUtility - Makefile
#

#
# Setup the executable that we will use.
#

add_executable(SensorCalUtility SensorCalUtility.cc)

#
# Specify libraries against which to link.
#

target_link_libraries (SensorCalUtility ${MULTISENSE_UTILITY_LIBS})

=== debian/changelog ===
ros-indigo-multisense-lib (4.0.0-0trusty) trusty; urgency=high

  * Added support for new firmware version 3.5 features.
    Rewrote urdf and launch files for ease of use.
  * Contributors: Ryan Keating <mailto:rkeating@carnegierobotics.com>

 -- Carnegie Robotics <support@carnegierobotics.com>  Mon, 06 Feb 2017 05:00:00 -0000

ros-indigo-multisense-lib (3.3.0-0trusty) trusty; urgency=high

  * Updated LibMultiSense to build under C++11. Added URDF for the MultiSense S7/S7S and BCAM. Added support for 16 bit mono images. Added support for the MultiSense ST21 thermal stereo camera. Added organized pointcloud publishing. Changed laser and camera pointcloud color fields to FLOAT32 for PCL compatibility. Changed default color image encoding to BGR8. Added spindle joint publishing via the ROS joint_state_publisher. Updated multisense_cal_check to handle various serial number entires. Added the launch-file sensor parameter to load different URDF’s on startup. Published camera info topics for each image topic (for unrectified topics K, D, and R are populated). Added default laser transform publishing to keep the laser TF tree valid even when there are no subscriptions to laser topics.
  * Changed license from LGPL to BSD in both the ROS Driver and LibMultiSense C++ library. Fixed bug in disparity image publishing.  Fixed bug in raw_cam_config publishing.  Fixed bug in building using rosbuild under Groovy, Hydro, Indigo, etc.  Fixed Jenkins linking issue with libpng. Fixed termination bug in process_bags.py.
  * Remove '-march=native' compiler options as it is causing assembler errors on some platforms (specifically: Haswell/12.04_amd64/ROS Hydro)
  * Add wire-protocol support for DirectedStreams on CRL's Monocular IP Camera. Misc. other bugfixes.
  * Adding support files for MultiSense-S21 and Mono IP Camera products
  * Add initial support for CRL's Mono IP Camera. Numerous fixes in catkin build infrastructure.
  * Add support for catkin and rosbuild (Builds under Fuerte, Groovy, Hydro, and Indigo). Transitioned laser calibration from KDL and joint_state_publisher to pure ROS TF messages. Add support for multiple Multisene units via namespacing and tf_prefix's. Modified default topic names to reflect the new namespacing parameters (Default base namespace is now /multisense rather than /multisense_sl). Add support for 3.1_beta sensor firmware which includes support for Multisense-S21 units. Please note that the 3.1 ROS driver release is fully backwards compatible with all 2.X firmware versions.
  * Release_3.0_beta: Add support for 3.0_beta sensor firmware (SGM hardware stereo core: disparity at all resolutions, 2:1 rectangular pixel modes, 64/128/256 disparity modes, hardware bi-lateral post-stereo disparity filter support with tuning), add colorized points2 topic, add pointcloud egde and range filtering, add raw left/right disparitiy image topics, add stereo-cost image topic, misc other feature enhancements and bugfixes.  Please note that the 3.0_beta release is fully backwards compatiblie with all 2.X firmware versions.
  * Release_2.3: Add support for 2.3 sensor firmware (IMU / CMV4000 support), add 'MultiSenseUpdater' firmware upgrade tool, add smart dynamic_reconfigure presentation, remove multisense_diagnostics/multisense_dashboard, wire protocol to version 3.0 (w/ support for forthcoming SGM core), misc. other bugfixes and feature enhancements.
  * Low-level c++ API to version 2.2
  * -Add PPS topic: /multisense_sl/pps (std_msgs/Time)
    -Corrected step size of color images, which now display correctly using image_view
    -Add 'network_time_sync' option to dynamic reconfigure
  * Imported Release 2.0 of MultiSense-SL ROS driver.
  * Contributors: David LaRose <mailto:dlr@carnegierobotics.com>, Eric Kratzer <mailto:ekratzer@carnegierobotics.com>, Matt Alvarado <mailto:malvarado@carnegierobotics.com>

 -- Carnegie Robotics <support@carnegierobotics.com>  Tue, 30 Sep 2014 04:00:00 -0000

=== debian/control ===
Source: ros-indigo-multisense-lib
Section: misc
Priority: extra
Maintainer: Carnegie Robotics <support@carnegierobotics.com>
Build-Depends: debhelper (>= 9.0.0), libpng12-dev, ros-indigo-catkin, ros-indigo-cv-bridge
Homepage: https://bitbucket.org/crl/multisense_ros
Standards-Version: 3.9.2

Package: ros-indigo-multisense-lib
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libpng12-dev, ros-indigo-cv-bridge
Description: multisense_lib

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
export DH_OPTIONS=-v --buildsystem=cmake
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/indigo/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh  $@

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/indigo" \
		-DCMAKE_PREFIX_PATH="/opt/ros/indigo"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-indigo-multisense-lib//opt/ros/indigo/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_auto_install
